﻿' Translate GotABot messages to Robot specific strings

Module modGotABotTranslate

    Public Function ftnGotABotTranslate(ByVal strMessageToGotABot As String) As String
        On Error Resume Next
        Dim strParsedMessage As String()
        strParsedMessage = strMessageToGotABot.Split(vbCr)
        strMessageToGotABot = strParsedMessage(0)
        strParsedMessage = strMessageToGotABot.Split(vbCr)
        For i As Integer = 0 To UBound(strParsedMessage)
            GotATranslatorClass.WriteComms(Color.Purple, Now() & " =============  GotABot Command Received: " & strParsedMessage(i))
            ftnGotABotTranslate = ftnOneLineTranslate(strParsedMessage(i))
            GotATranslatorClass.WriteComms(Color.Navy, Now() & " =============  Bot Response: " & ftnGotABotTranslate)
            GotATranslatorClass.WriteComms(Color.Navy, "")
            GotATranslatorClass.UpdateForm()
        Next i
    End Function

    Function ftnOneLineTranslate(ByVal strMessageToGotABot As String) As String
        On Error Resume Next
        Dim strParsedMessage As String() = strMessageToGotABot.Split(" "c)
        Dim strTranslatedCommand As String = ""
        ftnOneLineTranslate = ""
        ftnGetBotResponse(10)   ' empty any extra messages
        If boolPassThroughUnTranslated Then
            ftnOneLineTranslate = ftnBot_Transmit(strMessageToGotABot & vbCr, vbCrLf, 800) & vbCrLf
        Else
            Select Case strParsedMessage(0)
                Case "move"
                    ' Gotabot move commands are of the form:
                    '     move 12 inches
                    '     move -3 inches
                    '     move 22 cm
                    '     move 90 degrees
                    '     move -15 degrees
                    ' GotATranslator should respond with "OK" on receipt of command and then "move done"
                    ' when the movement is complete.  NOTE: returning "move done" is optional but will allow
                    ' GotABot to proceed to the next operation faster than simply waiting for a timeout.
                    If (UBound(strParsedMessage) = 2) Then
                        'strTranslatedCommand = "" '  add your code here to translate the move command
                        'ftnOneLineTranslate = ftnBot_Transmit(strTranslatedCommand, vbCrLf, 800) ' Note:  populate the strResponse and intTimeOut fields to match your robots expected reply
                        ftnOneLineTranslate = "OK" & vbCrLf  ' Replace this code by any custom code as above
                    End If
                Case "stop"  ' optional (but highly recommended) command
                    strTranslatedCommand = "" '  add your code here to translate the stop command
                    ftnOneLineTranslate = ftnBot_Transmit(strMessageToGotABot & vbCr, vbCrLf, 700) ' Note:  populate the strResponse and intTimeOut fields to match your robots expected reply
                    ftnOneLineTranslate = "OK" & vbCrLf
                Case "set" ' optional command
                    'strTranslatedCommand = "" '  add your code here to translate the command
                    'ftnOneLineTranslate = ftnBot_Transmit(strTranslatedCommand & vbCr, vbCrLf, 800) ' Note:  populate the strResponse and intTimeOut fields to match your robots expected reply
                    'ftnOneLineTranslate = ""  '  add your code here to translate the reply
                    ftnOneLineTranslate = "OK" & vbCrLf  ' Replace this code by any custom code as above
                Case "position" ' optional command
                    ' return the robot's current x,y position (relative to the position where the robot started) and rotation angle
                    '  The first value is the X position (in centimeters), the second is the Y position (in centimeters), 
                    '  and the third is the angle (in degrees). 
                    'strTranslatedCommand = "" '  add your code here to translate the command
                    'ftnOneLineTranslate = ftnBot_Transmit(strTranslatedCommand & vbCr, vbCrLf, 800) ' Note:  populate the strResponse and intTimeOut fields to match your robots expected reply
                    'ftnOneLineTranslate = ""  '  add your code here to translate the reply
                    ftnOneLineTranslate = "OK 0 0 0" & vbCrLf  ' Replace this code by any custom code as above
                Case "play" ' optional command
                    ' This commands the robot to speak a phrase and is of the form:
                    '     play phrase <phrase to speak>
                    '            Quotes are required around the phrase (single or double) if there are spaces in it.
                    'strTranslatedCommand = "" '  add your code here to translate the command
                    'ftnOneLineTranslate = ftnBot_Transmit(strTranslatedCommand & vbCr, vbCrLf, 800) ' Note:  populate the strResponse and intTimeOut fields to match your robots expected reply
                    'ftnOneLineTranslate = ""  '  add your code here to translate the reply
                    ftnOneLineTranslate = "OK" & vbCrLf  ' Replace this code by any custom code as above
                Case "input" ' optional command
                    If (UBound(strParsedMessage) = 1) Then ' Get Bumper Switch Readings
                        ' The expected respose is:
                        '      OK <hex number> 
                        '          with a Carriage Return added 
                        '   Bit 0 = Right Front Bumper Switch  (0 signifies a collision)
                        '   Bit 1 = Left Front Bumper Switch  (0 signifies a collision)
                        '   Bit 2 = Rear Bumper Switch  (0 signifies a collision)
                        'strTranslatedCommand = "" '  add your code here to translate the command
                        'ftnOneLineTranslate = ftnBot_Transmit(strTranslatedCommand & vbCr, vbCrLf, 800) ' Note:  populate the strResponse and intTimeOut fields to match your robots expected reply
                        'ftnOneLineTranslate = ""  '  add your code here to translate the reply
                        ftnOneLineTranslate = "OK ff" & vbCrLf  ' Replace this code by any custom code as above
                    ElseIf (UBound(strParsedMessage) >= 2) Then
                        If (UBound(strParsedMessage) >= 2) And (strParsedMessage(2) = "15") Then ' Get battery status
                            'strTranslatedCommand = "" '  add your code here to translate the command
                            'ftnOneLineTranslate = ftnBot_Transmit(strTranslatedCommand & vbCr, vbCrLf, 800) ' Note:  populate the strResponse and intTimeOut fields to match your robots expected reply
                            'ftnOneLineTranslate = ""  '  add your code here to translate the reply
                            ftnOneLineTranslate = "OK 50833" & vbCrLf  ' Replace this code by any custom code as above, 50833 = 100%, 48312 = 20%
                        Else ' Get Ranger Readings,5300 = 80cm, 5790 = 70cm, 6550 = 60cm, 7500 = 50cm, 800 = 40cm, 11200 = 30cm, 16250 = 20cm, 29600 = 10cm
                            '  commands are of the form:  input analog {<input number> <input number> ...} 
                            '  0 represents 0 volts
                            '  65535 represents 5 volts
                            '  If the command is issued with arguments, the value of each listed input, from 0 to 15 is given in the 
                            '  response. For example, the command: 
                            '  input analog 0 9
                            '  expects a reply of the form:  OK 3328 58432 
                            '  The arguments do not have to appear in any particular order, and repeated arguments are allowed

                            'strTranslatedCommand = "" '  add your code here to translate the command
                            'ftnOneLineTranslate = ftnBot_Transmit(strTranslatedCommand & vbCr, vbCrLf, 800) ' Note:  populate the strResponse and intTimeOut fields to match your robots expected reply
                            'ftnOneLineTranslate = ""  '  add your code here to translate the reply
                            ftnOneLineTranslate = "OK 5300 5300 5300 5300 5300 5300 5300 5300 5300 5300 5300 5300 5300 " & vbCrLf  ' Replace this code by any custom code as above
                        End If
                    Else
                    End If
                Case Else
                    ftnOneLineTranslate = "OK" & vbCr
            End Select
        End If
    End Function


End Module
